local HeadCount = LibStub("AceAddon-3.0"):GetAddon("HeadCount2")

do
	local BossEvent = {
		started = false,
		bosses = {},
		bossCount = 0,
		encounter = "",
	}
	function BossEvent:AddBoss(bossID, name, zone, encounter)
		assert(bossID,"Bossevent requires an ID")
		self.bosses[bossID] = {}
		self.bosses[bossID].name = name
		self.bosses[bossID].state = 1 -- Alive = 1, Dead = 2
		self.bosses[bossID].zone = zone
		self.bossCount = self.bossCount + 1
		self.started = true
		self.encounter = encounter
	end
	
	function BossEvent:Complete()
		if not self.started then return false end
		local db = 0
		for k,v in pairs(self.bosses) do
			if v.state == 2 then db = db + 1 end
		end
		if db == self.bossCount then return true end
		return false
	end
	function BossEvent:Stop()
		if not self.started then return end
		wipe(self.bosses)
		self.bossCount = 0
		self.started = false
	end
	function BossEvent:GetName(guid)
		if self.bosses[guid] then return self.bosses[guid].name end
	end
	function BossEvent:IsPresent(guid)
		return self.bosses[guid] and true or false 
	end
	function BossEvent:GetZone(guid)
		if self.bosses[guid] then return self.bosses[guid].zone end
	end
	function BossEvent:AddKill(guid)
		if self.bosses[guid] then self.bosses[guid].state = 2 end
	end
	function BossEvent:IsDead(guid)
		return bosses[guid] and bosses[guid].state == 2 or false
	end
	function BossEvent:IsAlive(guid)
		return bosses[guid] and bosses[guid].state == 1 or false
	end
	HeadCount.BossEvent = {}
	local BossEvent_MT = { __index = BossEvent }
	function HeadCount.BossEvent:New()
		local bossEvent = {}
		setmetatable(bossEvent,BossEvent_MT)
		return bossEvent
	end
end