local HeadCount = LibStub("AceAddon-3.0"):GetAddon("HeadCount2")
local date = date
local floor = floor
do
	local Time = {
		epoc = 0
	}
	function Time:GetMonth()
		local utcDateTime = date("*t", self.epoc)
		return utcDateTime.month
	end
	function Time:GetDay()
		return date("*t", self.epoc).day
	end
	function Time:GetYear()
		return date("*t", self.epoc).year
	end
	function Time:GetHour()
		return date("*t", self.epoc).hour
	end
	function Time:GetMinute()
		return date("*t", self.epoc).min
	end
	function Time:GetSecond()
		return date("*t", self.epoc).sec
	end
	function Time:AddWeeks(weeks)
		assert(type(weeks) == "number", "Unable to add weeks to the given time because the number of weeks is not a number.")
		local weeks = floor(weeks)
		local sec = weeks * 7 * 24 * 60 * 60	-- 7 days per week / 24 hours per day / 60 minutes per hour / 60 seconds per minute
		self.epoc = self.epoc + sec
	end
	function Time:AddDays(days)
		assert(type(days) == "number", "Unable to add days to the given time because the number of days is not a number.")
		local days = floor(days)
		local sec = days * 24 * 60 * 60	-- 24 hours per day / 60 minutes per hour / 60 seconds per minute
		self.epoc = self.epoc + sec	
	end
	function Time:Pack()
		return { ["seconds"] = self.epoc}
	end
	function Time:Init(data)
		if type(data) == "number" then
			self.epoc = data
		else
			self.epoc = data["seconds"]
		end
	end
	HeadCount.Time = {}
	local Time_MT = {__index = Time}
	function HeadCount.Time:New(epoc)
		local t = {}
		setmetatable(t,Time_MT)
		t:Init(epoc)
		return t
	end
end